import static java.lang.Math.*;
public class worldFunc{
    static vectorFunc v = new vectorFunc();
    static atomFunc a = new atomFunc();
    
    public static world MapReduce(world olWorld, double deltaT, int nThread)
    {
        world nuWorld = new world(olWorld);
        //map
        worldThread[] t = new worldThread[nThread];
        int tstart= 0;
        int tend= olWorld.atomQty/nThread;
        for (int j = 0 ; j<nThread; j++)
        {
            t[j] = new worldThread(olWorld, deltaT, tstart, tend);
            tstart = tend;
            if (j != nThread-1)
                tend += olWorld.atomQty/nThread;
            else
                tend = olWorld.atomQty;
            t[j].start();
        }
        //reduce
        for (int j=0; j<nThread; j++)
        {
            try {
               t[j].join();
            } catch (InterruptedException ignore) {}
            for (int i=0;i<t[j].end-t[j].start;i++)
                nuWorld.append(t[j].atomBatch[i]);
        }
        //done
        return nuWorld;
    }
    
    public static atom[] process(final world olWorld, double deltaT, int start, int end)
    {
        atom[] atomBatch = new atom[end-start];
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
            //reset forces
            nuAtom = a.zeroforce(olWorld.atomLst[i]);

            //hardcollision with the world
            vector delta = v.sub(olWorld.center, nuAtom.pos);
            double refDistSQ = pow(olWorld.radius- nuAtom.radius,2);
            double diffDistSQ = v.magSQ(delta) - refDistSQ;
            if (diffDistSQ > 0)
                nuAtom = a.addforce(nuAtom, a.invRepulseSQ(nuAtom, olWorld.center, (olWorld.radius- nuAtom.radius), v.magSQ(delta),50, 250000));

            //interatom forces
            for (int j=0; j<olWorld.atomQty; j++)
                if (i!=j)
                {
                    vector link = v.sub(nuAtom.pos, olWorld.atomLst[j].pos);     // get direction vector
                    double distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                    double restlenght = nuAtom.radius + olWorld.atomLst[j].radius;     // get collision threshold
                    if (distCentersSQ == 0.0d)                                               // check if position overlap
                        nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
                    else if (distCentersSQ < restlenght*restlenght)                          // check if collide
                        nuAtom = a.addforce(nuAtom, a.repulseSQ(nuAtom, olWorld.atomLst[j], restlenght, distCentersSQ, 50,250000));
                }

            //spring forces
            nuAtom = a.springForceSQ(nuAtom,olWorld.atomLst);

            //world forces
            nuAtom = a.gravity(nuAtom, olWorld.gravity);
            nuAtom = a.terminalforces(nuAtom);
            //velocitydrag
            nuAtom = a.velocitydrag(nuAtom, 0.99);
            //  wind
            //  etc
            
            //integrate
            nuAtom = a.integrate(nuAtom, deltaT);
            //termnialvelocity
            nuAtom = a.terminalvelocity(nuAtom);
            
            //
            //nuWorld.append(nuAtom);
            atomBatch[i-start] = nuAtom;
        }
        return atomBatch;
    }
    
};
