import java.awt.*;
import java.applet.*;
public class worldTest
{
    /*________________________________
    ___________Variable_____________*/
    //functor
    pigFunc pig = new pigFunc();
    worldFunc w = new worldFunc();
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    //constant
    int maxAtoms = 500;                             // max atom allowed
    double deltaT = 0.001d;                         // physics frame lenght
    
    world U = new world(maxAtoms, new vector(400,70), new vector(340,450), 240);

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        U.append(new atom(650, 250, 5, 12));         // spawn the square spring
        U.append(new atom(680, 290, 5, 12));
        U.append(new atom(680, 250, 5, 12));
        U.append(new atom(650, 290, 5, 12));
        
        U.append(new atom(580, 250, 5, 12));         // spawn the square spring
        U.append(new atom(610, 290, 5, 12));
        U.append(new atom(610, 250, 5, 12));
        U.append(new atom(580, 290, 5, 12));
        U.append(new atom(530, 270, 5, 12));         // spawn the square spring
        U.append(new atom(530, 290, 5, 12));
        U.append(new atom(550, 290, 5, 12));
        U.append(new atom(550, 270, 5, 12));
        
        for (int i=0;i<5;i++)                       // atom fountain machine 
        {
            U.append(new atom(760, 82, 6, 4));
        }
        for (int i=5;i<8;i++)
        {
            U.append(new atom(600, 80, 8, 5));
        }
        for (int i=8;i<15;i++)
        {
            U.append(new atom(530, 20, 52, 8));
        }
        for (int i=15;i<maxAtoms;i++)
        {
            U.append(new atom(640, 440, 20, 3));
        }
                                                                // make some springs; hardcoded
        //new spring struct
        
        U.atomLst[0] = a.linkWith(U.atomLst[0],1,v.dist(U.atomLst[0].pos, U.atomLst[1].pos));
        U.atomLst[1] = a.linkWith(U.atomLst[1],0,v.dist(U.atomLst[0].pos, U.atomLst[1].pos));
        U.atomLst[2] = a.linkWith(U.atomLst[2],3,v.dist(U.atomLst[2].pos, U.atomLst[3].pos));
        U.atomLst[3] = a.linkWith(U.atomLst[3],2,v.dist(U.atomLst[2].pos, U.atomLst[3].pos));
        U.atomLst[1] = a.linkWith(U.atomLst[1],2,v.dist(U.atomLst[1].pos, U.atomLst[2].pos));
        U.atomLst[3] = a.linkWith(U.atomLst[3],1,v.dist(U.atomLst[3].pos, U.atomLst[1].pos));
        U.atomLst[2] = a.linkWith(U.atomLst[2],0,v.dist(U.atomLst[2].pos, U.atomLst[0].pos));
        U.atomLst[3] = a.linkWith(U.atomLst[3],0,v.dist(U.atomLst[3].pos, U.atomLst[0].pos));
        U.atomLst[2] = a.linkWith(U.atomLst[2],1,v.dist(U.atomLst[1].pos, U.atomLst[2].pos));
        U.atomLst[1] = a.linkWith(U.atomLst[1],3,v.dist(U.atomLst[3].pos, U.atomLst[1].pos));
        U.atomLst[0] = a.linkWith(U.atomLst[0],2,v.dist(U.atomLst[2].pos, U.atomLst[0].pos));
        U.atomLst[0] = a.linkWith(U.atomLst[0],3,v.dist(U.atomLst[3].pos, U.atomLst[0].pos));
        
        U.atomLst[4] = a.linkWith(U.atomLst[4],5,v.dist(U.atomLst[4].pos, U.atomLst[5].pos));
        U.atomLst[6] = a.linkWith(U.atomLst[6],7,v.dist(U.atomLst[6].pos, U.atomLst[7].pos));
        U.atomLst[5] = a.linkWith(U.atomLst[5],6,v.dist(U.atomLst[5].pos, U.atomLst[6].pos));
        U.atomLst[7] = a.linkWith(U.atomLst[7],5,v.dist(U.atomLst[7].pos, U.atomLst[5].pos));
        U.atomLst[6] = a.linkWith(U.atomLst[6],4,v.dist(U.atomLst[6].pos, U.atomLst[4].pos));
        U.atomLst[7] = a.linkWith(U.atomLst[7],4,v.dist(U.atomLst[7].pos, U.atomLst[4].pos));

        U.atomLst[5] = a.linkWith(U.atomLst[5],4,v.dist(U.atomLst[4].pos, U.atomLst[5].pos));
        U.atomLst[7] = a.linkWith(U.atomLst[7],6,v.dist(U.atomLst[6].pos, U.atomLst[7].pos));
        U.atomLst[6] = a.linkWith(U.atomLst[6],5,v.dist(U.atomLst[5].pos, U.atomLst[6].pos));
        U.atomLst[5] = a.linkWith(U.atomLst[5],7,v.dist(U.atomLst[7].pos, U.atomLst[5].pos));
        U.atomLst[4] = a.linkWith(U.atomLst[4],6,v.dist(U.atomLst[6].pos, U.atomLst[4].pos));
        U.atomLst[4] = a.linkWith(U.atomLst[4],7,v.dist(U.atomLst[7].pos, U.atomLst[4].pos));
       
        U.atomLst[8] = a.linkWith(U.atomLst[8],7,v.dist(U.atomLst[8].pos, U.atomLst[7].pos));
        U.atomLst[9] = a.linkWith(U.atomLst[9],7,v.dist(U.atomLst[9].pos, U.atomLst[7].pos));
        U.atomLst[9] = a.linkWith(U.atomLst[9],6,v.dist(U.atomLst[9].pos, U.atomLst[6].pos));
        U.atomLst[8] = a.linkWith(U.atomLst[8],9,v.dist(U.atomLst[8].pos, U.atomLst[9].pos));

        U.atomLst[7] = a.linkWith(U.atomLst[7],8,v.dist(U.atomLst[8].pos, U.atomLst[7].pos));
        U.atomLst[7] = a.linkWith(U.atomLst[7],9,v.dist(U.atomLst[9].pos, U.atomLst[7].pos));
        U.atomLst[6] = a.linkWith(U.atomLst[6],9,v.dist(U.atomLst[9].pos, U.atomLst[6].pos));
        U.atomLst[9] = a.linkWith(U.atomLst[9],8,v.dist(U.atomLst[8].pos, U.atomLst[9].pos));
   
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        U = w.refresh(U, deltaT, 4);
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("World Test",502,64);

        for (int i=0; i<maxAtoms; i++)
        {
            if (U.atomLst[i].rested == true)                // if rested, draw red
            {
                g.setColor(Color.red);
                pig.circle(g, U.atomLst[i].pos, U.atomLst[i].radius);
            }
            else                                            // if moving, draw blue
            {
                g.setColor(Color.blue);
                pig.circle(g, U.atomLst[i].pos, U.atomLst[i].radius);
            }
        }
        
        g.setColor(Color.green);
        for (int i =0;i<U.atomQty;i++)
            for (int j=0; j<U.atomLst[i].linkQty;j++)
            {
                pig.line(g, U.atomLst[i].pos, U.atomLst[U.atomLst[i].linkedTo[j]].pos);
            }
        
        g.setColor(Color.red);
        pig.circle(g, U.center, (int)U.radius);
    }
}
